---
# - include_tasks: roles/container_base/tasks/set_uid_and_gid.yml
- name: Set environment
  ansible.builtin.include_role:
    name: podman_systemd
    tasks_from: init.yml

- name: Calculate the expected command output
  ansible.builtin.set_fact:
    _postgres_user_exists: "NOTICE:  Role {{ postgres.user }} already exists."

- name: "Create postgres user '{{ postgres.user }}'"
  ansible.builtin.shell: >
            podman exec -it postgres psql -U {{ postgres_admin_user }} -c "
            DO
            \$do\$
            BEGIN
              IF EXISTS (
                  SELECT FROM pg_catalog.pg_roles
                  WHERE  rolname = '{{ postgres.user }}') THEN
                  RAISE NOTICE 'Role "{{ postgres.user }}" already exists. Skipping.';
              ELSE
                  CREATE ROLE {{ postgres.user }} LOGIN PASSWORD '{{ postgres.password }}';
              END IF;
            END
            \$do\$;"
  register: psql_result
  become_user: "{{ app_user }}"
  changed_when: _postgres_user_exists not in psql_result.stdout
  failed_when: psql_result.rc not in [1,0]
  no_log: true
  environment:
    PATH: "{{ homebrew_bin_dir }}:{{ ansible_env.PATH }}"
    XDG_RUNTIME_DIR: "{{ xdg_runtime_dir }}"
  retries: 5
  until: "psql_result is not failed"
  delay: 10

- name: "Create postgres database '{{ postgres.db }}'"
  ansible.builtin.shell: podman exec -it postgres psql -U {{ postgres_admin_user }} -tc "SELECT 1 FROM pg_database WHERE datname = '{{ postgres.db }}'" | grep -q 1 | podman exec -it postgres psql -U {{ postgres_admin_user }} -c "CREATE DATABASE {{ postgres.db }} with owner {{ postgres.user }}";
  register: psql_result
  become_user: "{{ app_user }}"
  changed_when: psql_result.rc == 129
  failed_when: psql_result.rc not in [1,129]
  environment:
    XDG_RUNTIME_DIR: "{{ xdg_runtime_dir }}"
    PATH: "{{ homebrew_bin_dir }}:{{ ansible_env.PATH }}"
  retries: 5
  until: "psql_result is not failed"
  delay: 10
